/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*******************************************************************************
Through the class parameter in constructor, this class is used to get passed class':
1. test method number;
2. test method (start with "test") name and put into String array;

and provide the test method number and name String array to testSuite to test.

 ******************************************************************************/

package com.ibm.rational.test.lm.spi.driver.test.util;

import java.lang.reflect.Method;

public class ClassTestMethod {
	
    private static final String TESTMETHODNAME_PREFIX = "test";
	
	private Object objclassToGetMethodName;
	private int iMethodNum = 0;
	private String[] aMethodNames = null;
	
	
	public ClassTestMethod(Object aobjclassToGetMethodName){
		this.objclassToGetMethodName = aobjclassToGetMethodName;
	}

	
	public void getClassDeclaredMethods(){
	    
	    String[] aTempMethod = null;
	    String strMethodName = null;
	    
	    Class<? extends Object> classToGetMethodName = objclassToGetMethodName.getClass();    	
    	Method[] aClassMethods =  classToGetMethodName.getDeclaredMethods();
    	
//		System.out.println("the total methods: " + aClassMethods.length);    	
		aTempMethod = new String [aClassMethods.length];		
    	for (int i = 0; i < aClassMethods.length; i++){
    		
    		strMethodName = aClassMethods[i].getName();    		
    		if (strMethodName.indexOf(TESTMETHODNAME_PREFIX) == 0){
    			//keep the method name in aTempMethod[iMethodName] and then iMethodNum ++...
    			aTempMethod[iMethodNum++] = strMethodName;
    			
 //	    		System.out.println(strMethodName);
    		}    		
    	}	    	
	    	
    	aMethodNames = new String [iMethodNum];
    	System.arraycopy(aTempMethod, 0, aMethodNames, 0, iMethodNum);		
	}

	
	public int getMethodNum(){
		return iMethodNum;
	}
		
	
	public String[] getMethodNames(){
		return aMethodNames;
	}
	
	
}
